
-- --------------------------------------------------
-- Entity Designer DDL Script for SQL Server 2005, 2008, and Azure
-- --------------------------------------------------
-- Date Created: 11/13/2013 00:09:47
-- Generated from EDMX file: C:\Users\Xavier\Documents\Visual Studio 2012\Projects\TFC2013_XMG_GestorDespeses\GestorDespesesLibrary\EFModel\GestorDespesesModel.edmx
-- --------------------------------------------------

SET QUOTED_IDENTIFIER OFF;
GO
USE [tfc];
GO
IF SCHEMA_ID(N'dbo') IS NULL EXECUTE(N'CREATE SCHEMA [dbo]');
GO

-- --------------------------------------------------
-- Dropping existing FOREIGN KEY constraints
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[FK_UserExpensesSheet]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[ExpensesSheets] DROP CONSTRAINT [FK_UserExpensesSheet];
GO
IF OBJECT_ID(N'[dbo].[FK_ExpensesSheetExpense]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Expenses] DROP CONSTRAINT [FK_ExpensesSheetExpense];
GO
IF OBJECT_ID(N'[dbo].[FK_HeadWorkers]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Users] DROP CONSTRAINT [FK_HeadWorkers];
GO
IF OBJECT_ID(N'[dbo].[FK_ExpenseTypeExpense]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Expenses] DROP CONSTRAINT [FK_ExpenseTypeExpense];
GO
IF OBJECT_ID(N'[dbo].[FK_UserWSSessionTokens]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[WSSessionTokens] DROP CONSTRAINT [FK_UserWSSessionTokens];
GO

-- --------------------------------------------------
-- Dropping existing tables
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[Users]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Users];
GO
IF OBJECT_ID(N'[dbo].[Expenses]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Expenses];
GO
IF OBJECT_ID(N'[dbo].[ExpensesSheets]', 'U') IS NOT NULL
    DROP TABLE [dbo].[ExpensesSheets];
GO
IF OBJECT_ID(N'[dbo].[Calendar]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Calendar];
GO
IF OBJECT_ID(N'[dbo].[SystemProperties]', 'U') IS NOT NULL
    DROP TABLE [dbo].[SystemProperties];
GO
IF OBJECT_ID(N'[dbo].[ExpenseTypes]', 'U') IS NOT NULL
    DROP TABLE [dbo].[ExpenseTypes];
GO
IF OBJECT_ID(N'[dbo].[WSSessionTokens]', 'U') IS NOT NULL
    DROP TABLE [dbo].[WSSessionTokens];
GO

-- --------------------------------------------------
-- Creating all tables
-- --------------------------------------------------

-- Creating table 'Users'
CREATE TABLE [dbo].[Users] (
    [UserId] int IDENTITY(1,1) NOT NULL,
    [Username] nvarchar(20)  NOT NULL,
    [Password] nchar(40)  NOT NULL,
    [Email] nvarchar(50)  NOT NULL,
    [FullName] nvarchar(50)  NOT NULL,
    [Type] int  NOT NULL,
    [ActivationCode] nchar(12)  NULL,
    [ActivationCodeDate] datetime  NULL,
    [UserHeadId] int  NULL
);
GO

-- Creating table 'Expenses'
CREATE TABLE [dbo].[Expenses] (
    [ExpensesId] int IDENTITY(1,1) NOT NULL,
    [Description] nvarchar(max)  NOT NULL,
    [Value] decimal(18,2)  NOT NULL,
    [Type] int  NOT NULL,
    [TypeConcept] nvarchar(40)  NOT NULL,
    [TypeValue] decimal(18,2)  NULL,
    [TypeMaxValue] decimal(18,2)  NULL,
    [TypeInvoiceThreshold] decimal(18,2)  NULL,
    [Date] datetime  NOT NULL,
    [DateIncrement] decimal(18,2)  NOT NULL,
    [IsOnHolidays] bit  NOT NULL,
    [InvoiceImage] varbinary(max)  NULL,
    [ExpensesSheetExpensesSheetId] int  NOT NULL,
    [ExpenseType_ExpenseTypeId] int  NULL
);
GO

-- Creating table 'ExpensesSheets'
CREATE TABLE [dbo].[ExpensesSheets] (
    [ExpensesSheetId] int IDENTITY(1,1) NOT NULL,
    [UserUserId] int  NOT NULL,
    [State] int  NOT NULL,
    [RevokedReason] nvarchar(255)  NULL,
    [LastStateChangedDate] datetime  NOT NULL
);
GO

-- Creating table 'Calendar'
CREATE TABLE [dbo].[Calendar] (
    [DayId] int IDENTITY(1,1) NOT NULL,
    [Date] datetime  NOT NULL,
    [Type] int  NOT NULL
);
GO

-- Creating table 'SystemProperties'
CREATE TABLE [dbo].[SystemProperties] (
    [SystemPropertiesId] int IDENTITY(1,1) NOT NULL,
    [Key] nvarchar(20)  NOT NULL,
    [Value] nvarchar(255)  NOT NULL
);
GO

-- Creating table 'ExpenseTypes'
CREATE TABLE [dbo].[ExpenseTypes] (
    [ExpenseTypeId] int IDENTITY(1,1) NOT NULL,
    [Concept] nvarchar(40)  NOT NULL,
    [Type] int  NOT NULL,
    [Value] decimal(18,2)  NULL,
    [MaxValue] decimal(18,2)  NULL,
    [InvoiceThreshold] decimal(18,2)  NULL
);
GO

-- Creating table 'WSSessionTokens'
CREATE TABLE [dbo].[WSSessionTokens] (
    [Token] nchar(20)  NOT NULL,
    [InitDateTime] datetime  NOT NULL,
    [lastAccessDateTime] datetime  NOT NULL,
    [User_UserId] int  NOT NULL
);
GO

-- --------------------------------------------------
-- Creating all PRIMARY KEY constraints
-- --------------------------------------------------

-- Creating primary key on [UserId] in table 'Users'
ALTER TABLE [dbo].[Users]
ADD CONSTRAINT [PK_Users]
    PRIMARY KEY CLUSTERED ([UserId] ASC);
GO

-- Creating primary key on [ExpensesId] in table 'Expenses'
ALTER TABLE [dbo].[Expenses]
ADD CONSTRAINT [PK_Expenses]
    PRIMARY KEY CLUSTERED ([ExpensesId] ASC);
GO

-- Creating primary key on [ExpensesSheetId] in table 'ExpensesSheets'
ALTER TABLE [dbo].[ExpensesSheets]
ADD CONSTRAINT [PK_ExpensesSheets]
    PRIMARY KEY CLUSTERED ([ExpensesSheetId] ASC);
GO

-- Creating primary key on [DayId] in table 'Calendar'
ALTER TABLE [dbo].[Calendar]
ADD CONSTRAINT [PK_Calendar]
    PRIMARY KEY CLUSTERED ([DayId] ASC);
GO

-- Creating primary key on [SystemPropertiesId] in table 'SystemProperties'
ALTER TABLE [dbo].[SystemProperties]
ADD CONSTRAINT [PK_SystemProperties]
    PRIMARY KEY CLUSTERED ([SystemPropertiesId] ASC);
GO

-- Creating primary key on [ExpenseTypeId] in table 'ExpenseTypes'
ALTER TABLE [dbo].[ExpenseTypes]
ADD CONSTRAINT [PK_ExpenseTypes]
    PRIMARY KEY CLUSTERED ([ExpenseTypeId] ASC);
GO

-- Creating primary key on [Token] in table 'WSSessionTokens'
ALTER TABLE [dbo].[WSSessionTokens]
ADD CONSTRAINT [PK_WSSessionTokens]
    PRIMARY KEY CLUSTERED ([Token] ASC);
GO

-- --------------------------------------------------
-- Creating all FOREIGN KEY constraints
-- --------------------------------------------------

-- Creating foreign key on [UserUserId] in table 'ExpensesSheets'
ALTER TABLE [dbo].[ExpensesSheets]
ADD CONSTRAINT [FK_UserExpensesSheet]
    FOREIGN KEY ([UserUserId])
    REFERENCES [dbo].[Users]
        ([UserId])
    ON DELETE CASCADE ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_UserExpensesSheet'
CREATE INDEX [IX_FK_UserExpensesSheet]
ON [dbo].[ExpensesSheets]
    ([UserUserId]);
GO

-- Creating foreign key on [ExpensesSheetExpensesSheetId] in table 'Expenses'
ALTER TABLE [dbo].[Expenses]
ADD CONSTRAINT [FK_ExpensesSheetExpense]
    FOREIGN KEY ([ExpensesSheetExpensesSheetId])
    REFERENCES [dbo].[ExpensesSheets]
        ([ExpensesSheetId])
    ON DELETE CASCADE ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_ExpensesSheetExpense'
CREATE INDEX [IX_FK_ExpensesSheetExpense]
ON [dbo].[Expenses]
    ([ExpensesSheetExpensesSheetId]);
GO

-- Creating foreign key on [UserHeadId] in table 'Users'
ALTER TABLE [dbo].[Users]
ADD CONSTRAINT [FK_HeadWorkers]
    FOREIGN KEY ([UserHeadId])
    REFERENCES [dbo].[Users]
        ([UserId])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_HeadWorkers'
CREATE INDEX [IX_FK_HeadWorkers]
ON [dbo].[Users]
    ([UserHeadId]);
GO

-- Creating foreign key on [ExpenseType_ExpenseTypeId] in table 'Expenses'
ALTER TABLE [dbo].[Expenses]
ADD CONSTRAINT [FK_ExpenseTypeExpense]
    FOREIGN KEY ([ExpenseType_ExpenseTypeId])
    REFERENCES [dbo].[ExpenseTypes]
        ([ExpenseTypeId])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_ExpenseTypeExpense'
CREATE INDEX [IX_FK_ExpenseTypeExpense]
ON [dbo].[Expenses]
    ([ExpenseType_ExpenseTypeId]);
GO

-- Creating foreign key on [User_UserId] in table 'WSSessionTokens'
ALTER TABLE [dbo].[WSSessionTokens]
ADD CONSTRAINT [FK_UserWSSessionTokens]
    FOREIGN KEY ([User_UserId])
    REFERENCES [dbo].[Users]
        ([UserId])
    ON DELETE CASCADE ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_UserWSSessionTokens'
CREATE INDEX [IX_FK_UserWSSessionTokens]
ON [dbo].[WSSessionTokens]
    ([User_UserId]);
GO

-- --------------------------------------------------
-- Script has ended
-- --------------------------------------------------