﻿using GestorDespeses.BI;
using GestorDespeses.Model;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace GestorDespesesLibraryTest
{
    [TestClass]
    public class ExpensesTests
    {
        private static int generatedUser = -1;

        [TestInitialize]
        public void Initialize()
        {
            if (generatedUser == -1)
            {
                UserBI usersManager = new UserBI();
                int res = usersManager.addUser("xminana",
                    "password",
                    "xminana@uoc.edu",
                    "Javier Miñana Garcia",
                    UserType.WORKER);
                generatedUser = res;
            }
        }

        [TestMethod]
        public void getExpesesSheetsOfUser()
        {
            ExpensesBI ExpensesBI = new ExpensesBI();
            List<ExpensesSheet> sheets = ExpensesBI.listExpensesSheetOfUser(generatedUser, new List<ExpensesSheetState>() { ExpensesSheetState.OPEN });
            Assert.AreEqual(sheets.Count, 1);
        }

        [TestMethod]
        public void Finalize()
        {
            UserBI usersManager = new UserBI();
            bool res = usersManager.deleteUser(generatedUser);
            Assert.AreNotEqual(res, false);
        }
    }
}
