﻿using GestorDespeses.Model;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Web;
using System.Text;

namespace GestorDespesesWS
{
    // NOTE: You can use the "Rename" command on the "Refactor" menu to change the interface name "IService1" in both code and config file together.
    //[ServiceContract(SessionMode = SessionMode.Required)]
    [ServiceContract]
    public interface IGestorDespesesWS
    {
        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        string login(string username, string password);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        bool logout(string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        List<UserData> listUsers(string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        List<UserData> listUsersByQuery(string q, int limit, string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        int addUser(string username, string password, string email, string fullName, UserType type, string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        bool editUser(int userHandler, string password, string email, string fullName, UserType type, string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        UserData getUser(int userHandler, string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        UserData getCurrentUser(string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        bool deleteUser(int userHandler, string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        bool generateValidationCode(string usernameOrEmail);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        bool changePassword(string newPassword, string activationCode);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        bool assignHead(int userHandler, int headHandler, string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        List<ExpenseTypeData> listExpenseTypes(string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        List<ExpenseTypeData> listExpenseTypesByQuery(string q, int limit, string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        ExpenseTypeData getExpenseType(int expenseTypeHandler, string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        int addExpenseType(string concept, decimal? value, decimal? maxValue, decimal? threshold, ExpenseTypeType type, string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        bool editExpenseType(int expenseTypeHandler, string concept, decimal? value, decimal? maxValue, decimal? threshold, ExpenseTypeType type, string token);
        
        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        bool deleteExpenseType(int expenseTypeHandler, string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        List<DayData> listMonthCalendar(int year, int month, string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        bool setCalendarHoliday(DateTime dateTime, string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        bool deleteCalendarHoliday(DateTime dateTime, string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        bool setCalendarValidationLimit(DateTime dateTime, string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        bool deleteCalendarValidationLimit(DateTime dateTime, string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        bool setHolidayIncrement(int percentage, string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        bool setWeekendIncrement(int percentage, string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        bool setValidationThreshold(int daysToSubstract, string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        bool setServiceSessionTimeout(int seconds, string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        bool configureSMTP(string fromEmail,
            string fromFullName,
            string password,
            string host,
            int port,
            bool enableSsl,
            string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        SMTPData getSMTPSettings(string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        string getCurrentExpensesRevokedReason(string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        ExpensesSheetState getCurrentExpensesState(string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        List<ExpenseData> getCurrentExpenses(string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        bool preValidateCurrentExpenses(string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        bool reOpenCurrentExpenses(string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        List<ExpensesSheetData> getExpenseSheetsHistory(string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        int addExpense(decimal value, DateTime date, string description, byte[] image, string expenseTypeConcept, string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        ExpenseData getExpense(int expenseHandler, string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        byte[] getExpenseInvoice(int expenseHandler, string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        bool editExpense(int expenseHandler, decimal value, DateTime date, string description, byte[] image, string expenseTypeConcept, string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        bool deleteExpense(int expenseHandler, string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        byte[] getInvoice(int expenseHandler, string token);

        //[OperationContract]
        //[FaultContract(typeof(GestorDespesesFault))]
        //List<ExpensesSheetData> getExpenseSheetsOfUserToValidate(int userHandler, string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        List<ExpensesSheetData> getExpensesSheetsToPay(string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        List<ExpensesSheetData> getExpensesSheetsToValidate(string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        bool payExpensesSheet(int expensesSheetHandler, string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        bool validateExpensesSheet(int expensesSheetHandler, string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        bool revokeExpensesSheet(int expensesSheetHandler, string reason, string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        List<ExpenseData> getExpensesOfExpensesSheet(int expensesSheetHandler, string token);

        [OperationContract]
        [FaultContract(typeof(GestorDespesesFault))]
        bool isCurrentUserHeadUser(string token);

    }

    [DataContract]
    public class GestorDespesesFault
    {
        [DataMember]
        public string Message { get; set; }
        [DataMember]
        public FaultCode ErrorCode { get; set; }
    }

    [DataContract]
    public enum FaultCode
    {
        [EnumMemberAttribute]
        NOT_AUTHORIZED,
        [EnumMemberAttribute]
        NOT_LOGGED,
        [EnumMemberAttribute]
        ARGUMENTS_ERROR,
        [EnumMemberAttribute]
        BUSINESS_ERROR,
        [EnumMemberAttribute]
        LOGIN_FAILED,
        [EnumMemberAttribute]
        UNKNOWN_ERROR
    }

    [DataContract]
    [KnownType(typeof(UserType))]
    public class UserData
    {
        [DataMember]
        public int UserHandler;
        [DataMember]
        public string Username;
        [DataMember]
        public string Email;
        [DataMember]
        public string FullName;
        [DataMember]
        public UserType Type;
        [DataMember]
        public List<int> ExpensesSheetHandlers;
        [DataMember]
        public List<int> WorkerHandlers;
        [DataMember]
        public int HeadHandler;
    }

    [DataContract]
    [KnownType(typeof(ExpenseTypeType))]
    public class ExpenseTypeData
    {
        [DataMember]
        public int ExpenseTypeHandler;
        [DataMember]
        public string Concept;
        [DataMember]
        public ExpenseTypeType Type;
        [DataMember]
        public decimal? Value;
        [DataMember]
        public decimal? MaxValue;
        [DataMember]
        public decimal? Threshold;
    }

    [DataContract]
    [KnownType(typeof(DayType))]
    public class DayData
    {
        [DataMember]
        public int DayHandler;
        [DataMember]
        public DayType Type;
        [DataMember]
        public DateTime Date;
    }

    [DataContract]
    [KnownType(typeof(ExpenseTypeType))]
    public class ExpenseData
    {
        [DataMember]
        public int ExpenseHandler;
        [DataMember]
        public decimal? Value;
        [DataMember]
        public string Description;
        [DataMember]
        public DateTime Date;
        [DataMember]
        public int TypeHandler;
        [DataMember]
        public ExpenseTypeType Type;
        [DataMember]
        public string TypeConcept;
        [DataMember]
        public decimal? TypeValue;
        [DataMember]
        public decimal? TypeMaxValue;
        [DataMember]
        public decimal? TypeInvoiceThreshold;
        [DataMember]
        public decimal DateIncrement;
        [DataMember]
        public bool IsOnHolidays;
        [DataMember]
        public bool IsOnWeekend;
        [DataMember]
        public bool HasInvoice;
        [DataMember]
        public decimal TotalValue;
    }

    [DataContract]
    [KnownType(typeof(ExpensesSheetState))]
    public class ExpensesSheetData
    {
        [DataMember]
        public int ExpensesSheetHandler;
        [DataMember]
        public string OwnerUsername;
        [DataMember]
        public decimal Value;
        [DataMember]
        public DateTime Date;
        [DataMember]
        public ExpensesSheetState State;
        [DataMember]
        public string RevokedReason;
    }

    [DataContract]
    [KnownType(typeof(ExpensesSheetState))]
    public class SMTPData
    {
        [DataMember]
        public string fromEmail;
        [DataMember]
        public string fromFullName;
        [DataMember]
        public string password;
        [DataMember]
        public string host;
        [DataMember]
        public int port;
        [DataMember]
        public bool enableSsl;
    }
}
