﻿using GestorDespesesWeb.GestorDespesesWS;
using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace GestorDespesesWeb.Account
{
    public partial class LogOff : System.Web.UI.Page
    {
        private static BasicHttpBinding binding = new BasicHttpBinding();
        private static EndpointAddress address = new EndpointAddress("http://192.168.1.75/GestorDespesesWS/GestorDespesesWS.svc");
        private static GestorDespesesWSClient client = new GestorDespesesWSClient(binding, address);
        
        protected void Page_Load(object sender, EventArgs e)
        {
            try
            {
                if (Session["userId"] == null)
                {
                    //Clear session information if something remains
                    Session["userType"] = null;
                    Session["fullName"] = null;
                    Session["token"] = null;

                    Response.Redirect("../Default.aspx", false);
                }
                else
                {
                    client.logout((string)Session["token"]);

                    //Clear session information
                    Session["userId"] = null;
                    Session["userType"] = null;
                    Session["fullName"] = null;
                    Session["token"] = null;

                    Response.Redirect("../Default.aspx", false);
                }
            }
            catch (FaultException<GestorDespesesFault> fedf)
            {
                if (fedf.Detail.Message.Equals("Token de sessió invàlid."))
                {
                    Response.Redirect("/Account/Login.aspx", false);
                }
                else
                {
                    Response.Redirect("/Error/UnexpectedError.aspx", false);
                }
            }
            catch
            {
                Response.Redirect("/Error/UnexpectedError.aspx", false);
            }
            finally
            {
                //Clear session information
                Session["userId"] = null;
                Session["userType"] = null;
                Session["fullName"] = null;
                Session["token"] = null;
            }
        }
    }
}