﻿using GestorDespesesWeb.GestorDespesesWS;
using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace GestorDespesesWeb.Account
{
    public partial class Login : System.Web.UI.Page
    {
        private static BasicHttpBinding binding = new BasicHttpBinding();
        private static EndpointAddress address = new EndpointAddress("http://192.168.1.75/GestorDespesesWS/GestorDespesesWS.svc");
        private static GestorDespesesWSClient client = new GestorDespesesWSClient(binding, address);

        protected void Page_Load(object sender, EventArgs e)
        {
            hlRecoverPassword.Text = "Has oblidat les teves credencials?";
            hlRecoverPassword.NavigateUrl = "/Account/Recover.aspx";
            alertTD.Visible = false;
        }

        protected void LoginButton_Click(object sender, EventArgs e)
        {
            try 
            {
                string token = client.login(UserName.Text, Password.Text);

                UserData user = client.getCurrentUser(token);

                //Fill session with user information
                Session["userId"] = user.UserHandler;
                Session["userType"] = user.Type;
                Session["fullName"] = user.FullName;
                Session["token"] = token;

                Response.Redirect("../Default.aspx", false);
            }
            catch (FaultException<GestorDespesesFault> fedf)
            {
                LoginAlert.Text = fedf.Detail.Message;
                alertTD.Visible = true;
            }
            catch (Exception)
            {
                Response.Redirect("/Error/UnexpectedError.aspx", false);
            }
        }
    }
}
