﻿using GestorDespesesWeb.GestorDespesesWS;
using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace GestorDespesesWeb.Account
{
    public partial class Recover : System.Web.UI.Page
    {
        private static BasicHttpBinding binding = new BasicHttpBinding();
        private static EndpointAddress address = new EndpointAddress("http://192.168.1.75/GestorDespesesWS/GestorDespesesWS.svc");
        private static GestorDespesesWSClient client = new GestorDespesesWSClient(binding, address);

        protected void Page_Load(object sender, EventArgs e)
        {
            alertChangePasswordTD.Visible = false;
            infoChangePasswordTD.Visible = false;
            InfoChangePassword.Text = "Contrasenya cambiada correctament.";

            alertValidateUserTD.Visible = false;
            infoValidateUserTD.Visible = false;
            InfoValidateUser.Text = "Codi generat i enviat per correu al usuari.";

            Info1.Text = "Se t'enviarà un codi d'activació a la teva bústia.";
            Info2.Text = "Si ja tens el teu codi d'activació introdueix-lo al següent formulari juntament amb les noves credencials.";
        }

        protected void ValidateUserButton_Click(object sender, EventArgs e)
        {
            try
            {
                bool result = client.generateValidationCode(UserOrEmail.Text);
                // Mostrem el missatge que l'acció s'ha executat correctament
                infoValidateUserTD.Visible = true;
            }
            catch (FaultException<GestorDespesesFault> fedf)
            {
                ValidateUserAlert.Text = fedf.Detail.Message;
                alertValidateUserTD.Visible = true;
            }
            catch (Exception)
            {
                Response.Redirect("/Error/UnexpectedError.aspx", false);
            }
        }

        protected void ChangePasswordButton_Click(object sender, EventArgs e)
        {
            try
            {
                bool result = client.changePassword(NewPassword.Text, Code.Text);
                // Mostrem el missatge que l'acció s'ha executat correctament
                infoChangePasswordTD.Visible = true;
            }
            catch (FaultException<GestorDespesesFault> fedf)
            {
                ChangePasswordAlert.Text = fedf.Detail.Message;
                alertChangePasswordTD.Visible = true;
            }
            catch (Exception)
            {
                Response.Redirect("/Error/UnexpectedError.aspx", false);
            }
        }
    }
}
