﻿<%@ Page Title="" Language="C#" MasterPageFile="~/GestorDespeses.Master" AutoEventWireup="true" CodeBehind="SystemProperties.aspx.cs" Inherits="GestorDespesesWeb.Admin.SystemProperties" %>
<asp:Content ID="Content1" ContentPlaceHolderID="HeadContent" runat="server">
    <script src="../Scripts/jquery.ui.datepicker-ca.js" type="text/javascript"></script>
    <script type="text/javascript" src="../Scripts/jquery.dataTables.js"></script>
    <script type="text/javascript">
        var actionColumn = '<input class="floatLeft ui-icon ui-icon-pencil edit_{0}" type="image" onclick="Edit({0});return false;" title="Editar">' +
                   '<input class="floatLeft ui-icon ui-icon-trash delete_{0}" type="image" onclick="Delete({0});return false;" title="Esborrar">';
        var oTable;
        var festius;
        //var ultimdia;

        function Delete(expenseTypeId) {
            showConfirm("Esborrar tipus de despesa",
                "Està segur que vol esborrar el tipus de despesa?",
                function () {
                    $.ajax({
                        type: "POST",
                        url: "SystemProperties.aspx/deleteExpenseType",
                        data: "{expenseTypeId:'" + expenseTypeId + "'}",
                        dataType: "json",
                        contentType: "application/json; charset=utf-8",
                        success: function (data) {
                            if (data.d.success) {
                                var target_row = $('.delete_' + expenseTypeId).closest("tr").get(0); // this line did the trick
                                var aPos = oTable.fnGetPosition(target_row);
                                oTable.fnDeleteRow(aPos);
                                showInfo("Tipus de despesa esborrat correctament.");
                            } else {
                                if (data.d.error == "Token de sessió invàlid.") { location.replace("/Account/Login.aspx"); } else { showError(data.d.error); }
                            }
                        },
                        error: function (XMLHttpRequest, textStatus, errorThrown) {
                            showError('Error al esborrar un tipus de despesa');
                        }
                    });
                },
                function () {
                    return false;
                }
            );
        }

        function disableEnableType() {
            var selectedOption = $("#NewEditExpenseTypeType option:selected").val();
            if (selectedOption == 0) {
                $('#NewEditExpenseTypeValue').prop('disabled', false);
                $('#NewEditExpenseTypeMaxValue').prop('disabled', true);
                $('#NewEditExpenseTypeThreshold').prop('disabled', true);
                $('#NewEditExpenseTypeMaxValue').val('');
                $('#NewEditExpenseTypeThreshold').val('');
            } else if (selectedOption == 1) {
                $('#NewEditExpenseTypeValue').prop('disabled', true);
                $('#NewEditExpenseTypeMaxValue').prop('disabled', false);
                $('#NewEditExpenseTypeThreshold').prop('disabled', false);
                $('#NewEditExpenseTypeValue').val('');
            } else {
                $('#NewEditExpenseTypeValue').prop('disabled', false);
                $('#NewEditExpenseTypeMaxValue').prop('disabled', false);
                $('#NewEditExpenseTypeThreshold').prop('disabled', false);
            }
        }

        function Add() {
            //Fem neteja dels camps del modal
            $('#NewEditExpenseTypeName').val('');
            $('#NewEditExpenseTypeType option:first-child').prop('selected', true);
            disableEnableType();
            $('#NewEditExpenseTypeValue').val('');
            $('#NewEditExpenseTypeMaxValue').val('');
            $('#NewEditExpenseTypeThreshold').val('');
            $("#dialog-add-edit").dialog({
                title: 'Nou tipus de despesa',
                resizable: false,
                height: 250,
                width: 370,
                modal: true,
                buttons: {
                    "Afegir": function () {
                        var name = $('#NewEditExpenseTypeName').val();
                        var type = $('#NewEditExpenseTypeType option:selected').val();
                        var typeText = $('#NewEditExpenseTypeType option:selected').text();
                        var value = $('#NewEditExpenseTypeValue').val();
                        var dvalue = value == "" ? -1 : value
                        var svalue = value == "" ? "--" : value
                        var maxvalue = $('#NewEditExpenseTypeMaxValue').val();
                        var dmaxvalue = maxvalue == "" ? -1 : maxvalue
                        var smaxvalue = maxvalue == "" ? "--" : maxvalue
                        var threshold = $('#NewEditExpenseTypeThreshold').val();
                        var dthreshold = threshold == "" ? -1 : threshold
                        var sthreshold = threshold == "" ? "--" : threshold
                        $.ajax({
                            type: "POST",
                            url: "SystemProperties.aspx/addEditExpenseType",
                            data: "{expenseTypeId:'-1', name:'" + name + "', type:'" + type + "', value:'" + dvalue + "', maxValue:'" + dmaxvalue + "', threshold:'" + dthreshold + "'}",
                            dataType: "json",
                            contentType: "application/json; charset=utf-8",
                            success: function (data) {
                                if (data.d.success) {
                                    if (data.d.expenseTypeId > 0) {
                                        var newActionColumn = String.format(actionColumn, data.d.expenseTypeId);
                                        oTable.dataTable().fnAddData([data.d.expenseTypeId, name, typeText, svalue, smaxvalue, sthreshold, newActionColumn]);
                                        oTable.fnDraw();
                                        showInfo("Tipus de despesa afegit correctament.");
                                        $(this).dialog("close");
                                    } else {
                                        showError('Error al afegir un tipus de despesa');
                                    }
                                }
                                else
                                {
                                    if(data.d.error == "Token de sessió invàlid.") { location.replace("/Account/Login.aspx"); } else { showError(data.d.error); }
                                }
                            },
                            error: function (XMLHttpRequest, textStatus, errorThrown) {
                                showError('Error al afegir un tipus de despesa');
                            }
                        });
                    },
                    "Cancel·lar": function () {
                        $(this).dialog("close");
                    }
                }
            });
        }

        function Edit(expenseTypeId) {
            $.ajax({
                type: "POST",
                url: "SystemProperties.aspx/getExpenseType",
                data: "{expenseTypeId: '" + expenseTypeId + "'}",
                dataType: "json",
                contentType: "application/json; charset=utf-8",
                success: function (data) {
                    if (data.d.success) {
                        $('#NewEditExpenseTypeName').val(data.d.expenseType.Concept);
                        $('#NewEditExpenseTypeType option').eq(data.d.expenseType.Type).prop('selected', true);  // To select via value;
                        disableEnableType();
                        $('#NewEditExpenseTypeValue').val(data.d.expenseType.Value);
                        $('#NewEditExpenseTypeMaxValue').val(data.d.expenseType.MaxValue);
                        $('#NewEditExpenseTypeThreshold').val(data.d.expenseType.Threshold);
                        $("#dialog-add-edit").dialog({
                            title: 'Editar usuari',
                            resizable: false,
                            height: 250,
                            width: 370,
                            modal: true,
                            buttons: {
                                "Editar": function () {
                                    var name = $('#NewEditExpenseTypeName').val();
                                    var type = $('#NewEditExpenseTypeType option:selected').val();
                                    var typeText = $('#NewEditExpenseTypeType option:selected').text();
                                    var value = $('#NewEditExpenseTypeValue').val();
                                    var dvalue = value == "" ? -1 : value
                                    var svalue = value == "" ? "--" : value
                                    var maxvalue = $('#NewEditExpenseTypeMaxValue').val();
                                    var dmaxvalue = maxvalue == "" ? -1 : maxvalue
                                    var smaxvalue = maxvalue == "" ? "--" : maxvalue
                                    var threshold = $('#NewEditExpenseTypeThreshold').val();
                                    var dthreshold = threshold == "" ? -1 : threshold
                                    var sthreshold = threshold == "" ? "--" : threshold
                                    $.ajax({
                                        type: "POST",
                                        url: "SystemProperties.aspx/addEditExpenseType",
                                        data: "{expenseTypeId:'" + expenseTypeId + "', name:'" + name + "', type:'" + type + "', value:'" + dvalue + "', maxValue:'" + dmaxvalue + "', threshold:'" + dthreshold + "'}",
                                        dataType: "json",
                                        contentType: "application/json; charset=utf-8",
                                        success: function (data) {
                                            if (data.d.success) {
                                                if (data.d.expenseTypeId > 0) {
                                                    //Delete old row
                                                    var target_row = $('.delete_' + expenseTypeId).closest("tr").get(0); // this line did the trick
                                                    var aPos = oTable.fnGetPosition(target_row);
                                                    oTable.fnDeleteRow(aPos);
                                                    //reinsert row with new information
                                                    var newActionColumn = String.format(actionColumn, expenseTypeId);
                                                    oTable.dataTable().fnAddData([expenseTypeId, name, typeText, svalue, smaxvalue, sthreshold, newActionColumn]);
                                                    oTable.fnDraw();
                                                    showInfo("Tipus de despesa modificat correctament.");
                                                    $(this).dialog("close");
                                                } else {
                                                    showError('Error al editar un tipus de despesa');
                                                }
                                            }
                                            else
                                            {
                                                if(data.d.error == "Token de sessió invàlid.") { location.replace("/Account/Login.aspx"); } else { showError(data.d.error); }
                                            }
                                        },
                                        error: function (XMLHttpRequest, textStatus, errorThrown) {
                                            showError('Error al editar un tipus de despesa');
                                        }
                                    });
                                },
                                "Cancel·lar": function () {
                                    $(this).dialog("close");
                                }
                            }
                        });
                    }
                    else
                    {
                        if(data.d.error == "Token de sessió invàlid.") { location.replace("/Account/Login.aspx"); } else { showError(data.d.error); }
                    }
                },
                error: function (XMLHttpRequest, textStatus, errorThrown) {
                    alert("Status: " + XMLHttpRequest.status + "\r\n" + textStatus + "\r\n" + errorThrown);
                }
            });
        }

        function changeSMTPSettings()
        {
            $.ajax({
                type: "POST",
                url: "SystemProperties.aspx/changeSMTPSettings",
                data: "{host:'" + $('#SMTPHost').val()
                    + "', port:'" + $('#SMTPPort').val()
                    + "', tls:'" + $('#SMTPTLS').prop('checked') 
                    + "', from:'" + $('#SMTPFrom').val()
                    + "', username:'" + $('#SMTPUsername').val()
                    + "', password:'" + $('#SMTPPassword').val() + "'}",
                dataType: "json",
                contentType: "application/json; charset=utf-8",
                success: function (data) {
                    if (data.d.success) {
                        $('#btSMTP').prop('disabled', true);
                        showInfo('Paràmetres de SMTP modificats correctament');
                    } else {
                        if(data.d.error == "Token de sessió invàlid.") { location.replace("/Account/Login.aspx"); } else { showError(data.d.error); }
                    }
                },
                error: function (XMLHttpRequest, textStatus, errorThrown) {
                    showError('Error al recuperar les dates del calendari');
                }
            });
        }

        function getSMTPSettings() {
            $.ajax({
                type: "POST",
                url: "SystemProperties.aspx/getSMTPSettings",
                data: "",
                dataType: "json",
                contentType: "application/json; charset=utf-8",
                success: function (data) {
                    if (data.d.success) {
                        $('#SMTPHost').val(data.d.smtp.host);
                        $('#SMTPPort').val(data.d.smtp.port);
                        $('#SMTPTLS').prop('checked', data.d.smtp.enableSsl);
                        $('#SMTPFrom').val(data.d.smtp.fromEmail);
                        $('#SMTPUsername').val(data.d.smtp.fromFullName);
                        $('#SMTPPassword').val(data.d.smtp.password);
                        $('#btSMTP').prop('disabled', true);
                    } else {
                        if(data.d.error == "Token de sessió invàlid.") { location.replace("/Account/Login.aspx"); } else { showError(data.d.error); }
                    }
                },
                error: function (XMLHttpRequest, textStatus, errorThrown) {
                    showError('Error al recuperar les dates del SMTP');
                }
            });
        }

        function loadCalendarInfo(year, month)
        {
            $.ajax({
                type: "POST",
                url: "SystemProperties.aspx/getCalendarInfo",
                data: "{year:'" + year + "', month:'" + month + "'}",
                dataType: "json",
                contentType: "application/json; charset=utf-8",
                success: function (data) {
                    if (data.d.success) {
                        festius.length = 0; // esborrem l'array
                        $.each(data.d.dates, function (index, d) {
                            var date = new Date(parseInt(d.Date.substr(6)));
                            if (d.Type == 0) { festius.push(date.getTime()); } //Holiday
                            if (d.Type == 1) { ultimdia = date.getTime(); } //Max
                        });
                        $("#datepicker").datepicker('refresh');
                    }
                    else {
                        if(data.d.error == "Token de sessió invàlid.") { location.replace("/Account/Login.aspx"); } else { showError(data.d.error); }
                    }
                },
                error: function (XMLHttpRequest, textStatus, errorThrown) {
                    showError('Error al recuperar les dates del calendari');
                }
            });
        }

        function setDayType(year, month, day, type) {
            $.ajax({
                type: "POST",
                url: "SystemProperties.aspx/setDayType",
                data: "{year:'" + year + "', month:'" + month + "', day:'" + day + "', type:'" + type + "'}",
                dataType: "json",
                contentType: "application/json; charset=utf-8",
                success: function (data) {
                    if (data.d.success) {
                        loadCalendarInfo(year, month);
                    }
                    else {
                        if(data.d.error == "Token de sessió invàlid.") { location.replace("/Account/Login.aspx"); } else { showError(data.d.error); }
                    }
                },
                error: function (XMLHttpRequest, textStatus, errorThrown) {
                    showError('Error al recuperar les dates del calendari');
                }
            });
        }

        $(document).ready(function () {
            $('#NewEditExpenseTypeType').change(function (){
                disableEnableType();
            });

            getSMTPSettings();
            $('#SMTPHost').change(function () { $('#btSMTP').prop('disabled', false); });
            $('#SMTPPort').change(function () { $('#btSMTP').prop('disabled', false); });
            $('#SMTPTLS').change(function () { $('#btSMTP').prop('disabled', false); });
            $('#SMTPFrom').change(function () { $('#btSMTP').prop('disabled', false); });
            $('#SMTPUsername').change(function () { $('#btSMTP').prop('disabled', false); });
            $('#SMTPPassword').change(function () { $('#btSMTP').prop('disabled', false); });

            festius = [];
            ultimdia = new Date();

            var date = new Date();
            var curr_month = date.getMonth() + 1; //Months are zero based
            var curr_year = date.getFullYear();
            loadCalendarInfo(curr_year,curr_month);

            $("#datepicker").datepicker(
            {
                beforeShowDay: function (date) {
                    if (date.getTime() === ultimdia && ($.inArray(date.getTime(), festius) > -1)) {
                        return [true, 'datepicker-limit-festiu', 'Dia limit i festiu'];
                    } else if ($.inArray(date.getTime(), festius) != -1) {
                        return [true, 'datepicker-festiu', 'Festiu'];
                    } else if (date.getTime() === ultimdia) {
                        return [true, 'datepicker-limit', 'Dia limit'];
                    } else {
                        return [true, '', ''];
                    }
                },
                onChangeMonthYear: function (year, month, widget) {
                    loadCalendarInfo(year, month);
                },
                onSelect: function (date, inst) {
                    if ($(this).datepicker('getDate').getTime() === ultimdia && ($.inArray($(this).datepicker('getDate').getTime(), festius) > -1)) {
                        $('#HolidayLimitDay').prop('checked', true);
                    } else if ($.inArray($(this).datepicker('getDate').getTime(), festius) > -1) {
                        $('#Holiday').prop('checked', true);
                    } else if ($(this).datepicker('getDate').getTime() === ultimdia) {
                        $('#LimitDay').prop('checked', true);
                    } else {
                        $('#NormalDay').prop('checked', true);
                    }
                    var dayTypeOriginal = $("#dialogDay input[type='radio']:checked").val();
                    $("#dialogDay").dialog({
                        resizable: false,
                        height: 190,
                        width: 250,
                        modal: true,
                        buttons: {
                            "Acceptar": function () {
                                if (dayTypeOriginal != $("#dialogDay input[type='radio']:checked").val()) {
                                    var parts = date.split('/');
                                    setDayType(parts[2], parts[1], parts[0], $("#dialogDay input[type='radio']:checked").val());
                                }
                                $(this).dialog("close");
                            },
                            "Cancel·lar": function () {
                                $(this).dialog("close");
                            }
                        }
                    });
                }
            });
            $("#datepicker").datepicker($.datepicker.regional["ca"]);


            oTable = $('.tableSearcher').dataTable({
                "bJQueryUI": true,
                "sPaginationType": "full_numbers",
                "aoColumns": [ /* ID */  { "bVisible": false, "bSearchable": false }, null, null, null, null, null, { "bSearchable": false, 'bSortable': false }],
                "oLanguage": {
                    "sSearch": "Cercar:",
                    "sLengthMenu": "Mostrar _MENU_ tipus de despesa per pàgina",
                    "sZeroRecords": "Sense resultats",
                    "sEmptyTable": "No hi ha cap tipus de despesa",
                    "sInfo": "Mostrant _START_ fins _END_ d'un total de _TOTAL_ tipus de despesa",
                    "sInfoEmpty": "Mostrant 0 fins 0 d'un total de 0 tipus de despesa",
                    "sInfoFiltered": "(cerca filtrada d'un total de _MAX_ tipus de despesa)",
                    "oPaginate": {
                        "sFirst": "Primer",
                        "sLast": "Últim",
                        "sNext": "Següent",
                        "sPrevious": "Anterior"
                    }
                }
            });
        });
    </script>
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="BodyContent" runat="server">
    <div id="dialogDay" title="Selecciona el tipus de dia" style="display:none">
        <label><input type="radio" name="dayType" id="NormalDay" value="0"/>Normal</label><br>
        <label><input type="radio" name="dayType" id="Holiday" value="1"/>Festiu</label><br>
        <label><input type="radio" name="dayType" id="LimitDay" value="2"/>Dia Limit</label><br>
        <label><input type="radio" name="dayType" id="HolidayLimitDay" value="3"/>Festiu i dia limit</label>
    </div>
    <div id="dialog-add-edit" title="Afegir o editar tipus de despesa" style="display: none;">
        <table>
            <colgroup>
                <col span="1" style="width: 180px;" />
                <col span="1" style="width: 215px" />
            </colgroup>
            <tr>
                <td class="rightAlign" style="width:180px">
                    <label id="NewEditExpenseTypeNameLabel" for="NewEditExpenseTypeName">Nom:</label>
                </td>
                <td>
                    <input type="text" id="NewEditExpenseTypeName" class="textEntry ui-corner-all"/>
                </td>
            </tr>
            <tr>
                <td class="rightAlign" style="width:180px">
                    <label id="NewEditExpenseTypeTypeLabel" for="NewEditExpenseTypeType">Tipus:</label>
                </td>
                <td>
                    <select id="NewEditExpenseTypeType" class="textEntry ui-corner-all">
                        <option value="0">Fixe</option>
                        <option value="1">Variable</option>
                        <option value="2">Multiplicatiu</option>
                    </select>
                </td>
            </tr>
            <tr>
                <td class="rightAlign" style="width:180px">
                    <label id="NewEditExpenseTypeValueLabel" for="NewEditExpenseTypeValue">Valor:</label>
                </td>
                <td>
                    <input type="text" id="NewEditExpenseTypeValue" class="textEntry ui-corner-all"/>
               </td>
            </tr>
            <tr>
                <td class="rightAlign" style="width:180px">
                    <label id="NewEditExpenseTypeMaxValueLabel" for="NewEditExpenseTypeMaxValue">Valor Màxim:</label>
                </td>
                <td>
                    <input type="text" id="NewEditExpenseTypeMaxValue" class="textEntry ui-corner-all" />
                </td>
            </tr>
            <tr>
                <td class="rightAlign" style="width:180px">
                    <label id="NewEditExpenseTypeThresholdLabel" for="NewEditExpenseTypeThreshold">Tiquet a partir de:</label>
                </td>
                <td>
                    <input type="text" id="NewEditExpenseTypeThreshold" class="textEntry ui-corner-all"/>
                </td>
            </tr>
        </table>
    </div>
    <div>
        <table style="width:100%;border:1px">
            <colgroup>
                <col span="1" style="width: auto;" />
                <col span="1" style="width: auto;" />
            </colgroup>
            <tr>
                <td style="width:100px;height:100px;">
                    <asp:Image ID="ImgConfig" runat="server" Height="100px" Width="100px" ImageUrl="/images/config.png"  />
                </td>
            </tr>
            <tr>
                <td>        
                    <table class="generalBox">
                        <colgroup>
                            <col span="1" style="width: 180px;" />
                            <col span="1" style="width: 215px" />
                        </colgroup>
                        <tr>
                            <td colspan="2">
                                <div style="padding:1px;">
                                    <h2>Configuració SMTP</h2>
                                </div>
                            </td>
                        </tr>
                        <tr>
                            <td class="rightAlign" style="width:180px">
                                <label id="SMTPHostLabel" for="SMTPHost">Host:</label>
                            </td>
                            <td>
                                <input type="text" id="SMTPHost" class="textEntry ui-corner-all"/>
                            </td>
                        </tr>
                        <tr>
                            <td class="rightAlign" style="width:180px">
                                <label id="SMTPPortLabel" for="SMTPPort">Port:</label>
                            </td>
                            <td>
                                <input type="text" id="SMTPPort" class="textEntry ui-corner-all"/>
                            </td>
                        </tr>
                        <tr>
                            <td class="rightAlign" style="width:180px">
                                <label id="SMTPFromLabel" for="SMTPFrom">From:</label>
                            </td>
                            <td>
                                <input type="text" id="SMTPFrom" class="textEntry ui-corner-all"/>
                           </td>
                        </tr>
                        <tr>
                            <td class="rightAlign" style="width:180px">
                                <label id="SMTPTLSLabel" for="SMTPTLS">TLS:</label>
                            </td>
                            <td>
                                <input type="checkbox" id="SMTPTLS" />
                            </td>
                        </tr>
                        <tr>
                            <td class="rightAlign" style="width:180px">
                                <label id="SMTPUsernameLabel" for="SMTPUsername">Usuari:</label>
                            </td>
                            <td>
                                <input type="text" id="SMTPUsername" class="textEntry ui-corner-all"/>
                            </td>
                        </tr>
                        <tr>
                            <td class="rightAlign" style="width:180px">
                                <label id="SMTPPasswordLabel" for="SMTPPassword">Contrasenya:</label>
                            </td>
                            <td>
                                <input type="password" id="SMTPPassword" class="passwordEntry ui-corner-all"/>
                            </td>
                        </tr>
                        <tr>
                            <td>
                            </td>
                            <td class="rightAlign">
                                <input type="button" id="btSMTP" value="Modificar SMTP" class="ui-button ui-widget ui-state-default ui-corner-all ui-button-text-only" onclick="javascript:changeSMTPSettings();" />
                            </td>
                        </tr>
                    </table>
                </td>
                <td><div id="datepicker"></div></td>
            </tr>
            <tr>
                <td colspan="2">
                    <div style="padding:0px 10px;">
                        <h2>Tipus de despeses</h2>
                    </div>
                </td>
            </tr>
            <tr>
                <td>
                    <div id="addNewSubmit" runat="server" style="padding:0px 10px 10px 10px;">
                        <input type="button" Value="Nou Tipus" class="ui-button ui-widget ui-state-default ui-corner-all ui-button-text-only" ID="NewExpenseTypeButton" onclick="javascript: Add();" />
                    </div>
                </td>
            </tr>
            <tr>
                <td colspan="2">
                    <asp:GridView ID="gwExpensesTypes" runat="server" CssClass="tableSearcher" AutoGenerateColumns="False" OnRowDataBound="gwExpensesTypes_RowDataBound" GridLines="None" ShowHeaderWhenEmpty="true">
                        <Columns>
                            <asp:BoundField DataField="ExpenseTypeHandler" HeaderText="Id" />
                            <asp:BoundField DataField="Concept" HeaderText="Concepte" />
                            <asp:BoundField DataField="Type" HeaderText="Tipus" />
                            <asp:BoundField DataField="Value" HeaderText="Valor/Valor x unitat(€)" />
                            <asp:BoundField DataField="MaxValue" HeaderText="Valor màxim" />
                            <asp:BoundField DataField="Threshold" HeaderText="Tiquet a partir de..." />
                            <asp:TemplateField HeaderText="Accions" HeaderStyle-Width="80px">
                                <ItemTemplate>
                                    <input class="floatLeft ui-icon ui-icon-pencil <%# string.Concat("edit_",Eval("ExpenseTypeHandler")) %>" type="image" onclick='<%# Eval("ExpenseTypeHandler", "Edit({0});return false;").ToString() %>' title="Editar">
                                    <input class="floatLeft ui-icon ui-icon-trash <%# string.Concat("delete_",Eval("ExpenseTypeHandler")) %>" type="image" onclick='<%# Eval("ExpenseTypeHandler", "Delete({0});return false;").ToString() %>' title="Esborrar">
                                </ItemTemplate>
                            </asp:TemplateField>
                        </Columns>
                    </asp:GridView>
                </td>
            </tr>
        </table>
    </div>
</asp:Content>
