﻿<%@ Page EnableEventValidation="false" Title="" Language="C#" MasterPageFile="~/GestorDespeses.Master" AutoEventWireup="true" CodeBehind="Users.aspx.cs" Inherits="GestorDespesesWeb.Admin.Users" %>
<asp:Content ID="Content1" ContentPlaceHolderID="HeadContent" runat="server">
    <style type="text/css">
        .ui-autocomplete-loading {
            background: white url('/images/ui-anim_basic_16x16.gif') right center no-repeat;
        }

        .ui-autocomplete-selected {
            background: white url('/images/ui-anim_basic_16x16.gif') right center no-repeat;
            background: white url('/images/check_16x16.png') right center no-repeat;
        }
    </style>
    <script type="text/javascript" src="../Scripts/jquery.dataTables.js"></script>
    <script type="text/javascript">
        var actionColumn = '<input class="floatLeft ui-icon ui-icon-pencil edit_{0}" type="image" onclick="Edit({0});return false;" title="Editar">' +
                            '<input class="floatLeft ui-icon ui-icon-trash delete_{0}" type="image" onclick="Delete({0});return false;" title="Esborrar">';
        var oTable;

        function loadUsers() {
            $.ajax({
                type: "POST",
                url: "Users.aspx/getUserList",
                dataType: "json",
                contentType: "application/json; charset=utf-8",
                success: function (data) {
                    if (data.d.success) {
                        oTable.fnClearTable();
                        $.each(data.d.list, function (index, d) {
                            var type = "Treballador";
                            if (d.Type == 2) { type = "Administrador"; }
                            if (d.WorkerHandlers.length > 0) { type = "Responsable"; }
                            var newActionColumn = String.format(actionColumn, d.UserHandler);
                            oTable.dataTable().fnAddData([d.UserHandler, d.FullName, type, d.Username, d.Email, newActionColumn]);
                        });
                        oTable.fnDraw();
                    }
                    else {
                        if (data.d.error == "Token de sessió invàlid.") { location.replace("/Account/Login.aspx"); } else { showError(data.d.error); }
                        return false;
                    }
                },
                error: function (xmlhttprequest, textstatus, errorthrown) {
                    //alert("status: " + xmlhttprequest.status + "\r\n" + textstatus + "\r\n" + errorthrown);
                    showError("Error al llistar usuaris");
                    return false;
                }
            });
        }

        function Delete(userId) {
            showConfirm("Esborrar usuari", 
                "Està segur que vol eliminar l'usuari?", 
                function () {
                    $.ajax({
                        type: "POST",
                        url: "Users.aspx/deleteUser",
                        data: "{userId:'" + userId + "'}",
                        dataType: "json",
                        contentType: "application/json; charset=utf-8",
                        success: function (data) {
                            if(data.d.success) {
                                loadUsers();
                                //var target_row = $('.delete_' + userId).closest("tr").get(0); // this line did the trick
                                //var aPos = oTable.fnGetPosition(target_row);
                                //oTable.fnDeleteRow(aPos);
                                showInfo("Usuari esborrat correctament.");
                            } else {
                                if(data.d.error == "Token de sessió invàlid.") { location.replace("/Account/Login.aspx"); } else { showError(data.d.error); }
                            }
                        },
                        error: function (XMLHttpRequest, textStatus, errorThrown) {
                            showError('Error al esborrar un usuari');
                        }
                    });
                },
                function () {
                    return false;
                }
            )
        }

        function Add() {
            //Fem neteja dels camps del modal
            $('#NewEditUserName').val('');
            $('#NewEditUserUserName').prop('disabled', false);
            $('#NewEditUserUserName').val('');
            $('#NewEditUserEmail').val('');
            $('#NewEditUserPassword').val('');
            $('#NewEditUserType option:first-child').prop('selected', true);
            $('#NewEditUserHead').removeClass("ui-autocomplete-selected");
            $('#NewEditUserHead').val('');
            $('#NewEditUserHeadId').val(-1);
            $("#dialog-add-edit").dialog({
                title: 'Nou usuari',
                resizable: false,
                height: 250,
                width: 350,
                modal: true,
                buttons: {
                    "Afegir": function () {
                        var fullname = $('#NewEditUserName').val();
                        var username = $('#NewEditUserUserName').val();
                        var email = $('#NewEditUserEmail').val();
                        var pass = $('#NewEditUserPassword').val();
                        var type = $('#NewEditUserType option:selected').val();
                        var typeText = $('#NewEditUserType option:selected').text();
                        var head = $('#NewEditUserHeadId').val();
                        $.ajax({
                            type: "POST",
                            url: "Users.aspx/addEditUser",
                            data: "{userId:'-1', username:'"+ username +"', password:'"+ pass +"', email:'"+ email +"', fullName:'"+ fullname +"', type:'"+ type +"', headId:'" + head +"'}",
                            dataType: "json",
                            contentType: "application/json; charset=utf-8",
                            success: function (data) {
                                if (data.d.success) {
                                    loadUsers();
                                    //var newActionColumn = String.format(actionColumn, data.d.userId);
                                    //oTable.dataTable().fnAddData([data.d.userId, fullname, typeText, username, email, newActionColumn]);
                                    //oTable.fnDraw();
                                    $("#dialog-add-edit").dialog("close");
                                    showInfo("Usuari afegit correctament.");
                                } else {
                                    if(data.d.error == "Token de sessió invàlid.") { location.replace("/Account/Login.aspx"); } else { showError(data.d.error); }
                                }
                            },
                            error: function (XMLHttpRequest, textStatus, errorThrown) {
                                showError('Error al afegir un usuari');
                            }
                        });
                    },
                    "Cancel·lar": function () {
                        $(this).dialog("close");
                    }
                }
            });
            var usersAutocomplete = $("#NewEditUserHead").autocomplete("widget");
            usersAutocomplete.insertAfter($("#dialog-add-edit").parent());
        }

        function Edit(userId) {
            $.ajax({
                type: "POST",
                url: "Users.aspx/getUser",
                data: "{userId: '" + userId + "'}",
                dataType: "json",
                contentType: "application/json; charset=utf-8",
                success: function (data) {
                    if(data.d.success) {
                        $('#NewEditUserName').val(data.d.user.FullName);
                        $('#NewEditUserUserName').prop('disabled', true);
                        $('#NewEditUserUserName').val(data.d.user.Username);
                        $('#NewEditUserEmail').val(data.d.user.Email);
                        $('#NewEditUserPassword').val('');
                        $('#NewEditUserType').val(data.d.user.Type);
                        if (data.d.user.HeadHandler != -1) {
                            $.ajax({
                                type: "POST",
                                url: "Users.aspx/getUser",
                                data: "{userId: '" + data.d.user.HeadHandler + "'}",
                                dataType: "json",
                                contentType: "application/json; charset=utf-8",
                                success: function (headData) {
                                    if (headData.d.success) {
                                        $('#NewEditUserHead').addClass("ui-autocomplete-selected");
                                        $('#NewEditUserHead').val(headData.d.user.Username);
                                        $('#NewEditUserHeadId').val(headData.d.user.UserHandler);
                                    }
                                    else
                                    {
                                        showError(headData.d.error);
                                        return false;
                                    }
                                },
                                error: function (XMLHttpRequest, textStatus, errorThrown) {
                                    //alert("Status: " + XMLHttpRequest.status + "\r\n" + textStatus + "\r\n" + errorThrown);
                                    showError("Error desconegut");
                                    return false;
                                }
                            });
                        } else {
                            $('#NewEditUserHead').removeClass("ui-autocomplete-selected");
                            $('#NewEditUserHead').val('');
                            $('#NewEditUserHeadId').val(-1);
                        }
                        $("#dialog-add-edit").dialog({
                            title: 'Editar usuari',
                            resizable: false,
                            height: 250,
                            width: 350,
                            modal: true,
                            buttons: {
                                "Editar": function () {
                                    var fullname = $('#NewEditUserName').val();
                                    var username = $('#NewEditUserUserName').val();
                                    var email = $('#NewEditUserEmail').val();
                                    var pass = $('#NewEditUserPassword').val();
                                    var type = $('#NewEditUserType option:selected').val();
                                    var typeText = $('#NewEditUserType option:selected').text();
                                    var head = $('#NewEditUserHeadId').val();
                                    $.ajax({
                                        type: "POST",
                                        url: "Users.aspx/addEditUser",
                                        data: "{userId:'" + userId + "', username:'" + username + "', password:'" + pass + "', email:'" + email + "', fullName:'" + fullname + "', type:'" + type + "', headId:'" + head + "'}",
                                        dataType: "json",
                                        contentType: "application/json; charset=utf-8",
                                        success: function (data) {
                                            if (data.d.success) {
                                                loadUsers();
                                                ////Delete old row
                                                //var target_row = $('.delete_' + userId).closest("tr").get(0); // this line did the trick
                                                //var aPos = oTable.fnGetPosition(target_row);
                                                //oTable.fnDeleteRow(aPos);
                                                ////reinsert row with new information
                                                //var newActionColumn = String.format(actionColumn, userId);
                                                //oTable.dataTable().fnAddData([userId, fullname, typeText, username, email, newActionColumn]);
                                                //oTable.fnDraw();
                                                $("#dialog-add-edit").dialog("close");
                                                showInfo("Usuari modificat correctament.");
                                            } else {
                                                if(data.d.error == "Token de sessió invàlid.") { location.replace("/Account/Login.aspx"); } else { showError(data.d.error); }
                                            }
                                        },
                                        error: function (XMLHttpRequest, textStatus, errorThrown) {
                                            showError('Error al editar un usuari');
                                        }
                                    });
                                },
                                "Cancel·lar": function () {
                                    $(this).dialog("close");
                                }
                            }
                        });
                        var usersAutocomplete = $("#NewEditUserHead").autocomplete("widget");
                        usersAutocomplete.insertAfter($("#dialog-add-edit").parent());
                    } else {
                        if(data.d.error == "Token de sessió invàlid.") { location.replace("/Account/Login.aspx"); } else { showError(data.d.error); }
                        return false;
                    }
                },
                error: function (XMLHttpRequest, textStatus, errorThrown) {
                    alert("Status: " + XMLHttpRequest.status + "\r\n" + textStatus + "\r\n" + errorThrown);
                }
            });
        }

        $(function () {
            $("#NewEditUserHead").autocomplete({
                source: function (request, response) {
                    $.ajax({
                        type: "POST",
                        url: "Users.aspx/getUsers",
                        data: "{searchParam:'" + request.term + "'}",
                        dataType: "json",
                        contentType: "application/json; charset=utf-8",
                        success: function (data) {
                            if (data.d.success) {
                                return response($.map(data.d.list, function (item) {
                                    return {
                                        label: item.Username + " (" + item.FullName + ")",
                                        value: item.Username,
                                        id: item.UserHandler
                                    }
                                }));
                            } else {
                                if(data.d.error == "Token de sessió invàlid.") { location.replace("/Account/Login.aspx"); } else { showError(data.d.error); }
                            }
                        },
                        error: function (XMLHttpRequest, textStatus, errorThrown) {
                            showError('Error al llistar usuaris');
                        }
                    });
                },
                minLength: 2,
                create: function (event, ui) {
                    $(this).removeClass("ui-autocomplete_selected");
                },
                open: function () {
                    $(this).removeClass("ui-corner-all").addClass("ui-corner-top");
                },
                close: function () {
                    $(this).removeClass("ui-corner-top").addClass("ui-corner-all");
                },
                select: function (event, ui) {
                    $(this).addClass("ui-autocomplete-selected");
                    if (ui.item) {
                        $('#NewEditUserHeadId').val(ui.item.id);
                    }
                },
                search: function (event, ui) {
                    $(this).removeClass("ui-autocomplete-selected");
                    $('#NewEditUserHeadId').val(-1);
                    console.log("Search item");
                }
            });
        });

        $(document).ready(function () {
            oTable = $('.tableSearcher').dataTable({
                "bJQueryUI": true,
                "sPaginationType": "full_numbers",
                "aoColumns": [ /* ID */  { "bVisible": false, "bSearchable": false }, null, null, null, null, { "bSearchable": false, 'bSortable': false }],
                "oLanguage": {
                    "sSearch": "Cercar:",
                    "sLengthMenu": "Mostrar _MENU_ usuaris per pàgina",
                    "sZeroRecords": "Sense resultats",
                    "sEmptyTable": "No hi ha cap usuari",
                    "sInfo": "Mostrant _START_ fins _END_ d'un total de _TOTAL_ usuaris",
                    "sInfoEmpty": "Mostrant 0 fins 0 d'un total de 0 usuaris",
                    "sInfoFiltered": "(cerca filtrada d'un total de _MAX_ usuaris)",
                    "oPaginate": {
                        "sFirst": "Primer",
                        "sLast": "Últim",
                        "sNext": "Següent",
                        "sPrevious": "Anterior"
                    }
                }
            });
        });
    </script>
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="BodyContent" runat="server">
    <div id="dialog-add-edit" title="Afegir o editar usuari" style="display: none;">
        <table>
            <colgroup>
                <col span="1" style="width: 180px;" />
                <col span="1" style="width: 215px" />
            </colgroup>
            <tr>
                <td class="rightAlign" style="width:180px">
                    <label id="NewEditUserNameLabel" for="NewEditUserName">Nom:</label>
                </td>
                <td>
                    <input type="text" id="NewEditUserName" class="textEntry ui-corner-all"/>
                </td>
            </tr>
            <tr>
                <td class="rightAlign" style="width:180px">
                    <label id="NewEditUserUserNameLabel" for="NewEditUserUserName">Username:</label>
                </td>
                <td>
                    <input type="text" id="NewEditUserUserName" class="textEntry ui-corner-all"/>
               </td>
            </tr>
            <tr>
                <td class="rightAlign" style="width:180px">
                    <label id="NewEditUserPasswordLabel" for="NewEditUserPassword">Contrasenya:</label>
                </td>
                <td>
                    <input type="password" id="NewEditUserPassword" class="passwordEntry ui-corner-all" />
                </td>
            </tr>
            <tr>
                <td class="rightAlign" style="width:180px">
                    <label id="NewEditUserEmailLabel" for="NewEditUserEmail">Email:</label>
                </td>
                <td>
                    <input type="text" id="NewEditUserEmail" class="textEntry ui-corner-all"/>
                </td>
            </tr>
            <tr>
                <td class="rightAlign" style="width:180px">
                    <label id="NewEditUserTypeLabel" for="NewEditUserType">Type:</label>
                </td>
                <td>
                    <select id="NewEditUserType" class="textEntry ui-corner-all">
                        <option value="1">Treballador</option>
                        <option value="2">Administrador</option>
                    </select>
                </td>
            </tr>
            <tr>
                <td class="rightAlign" style="width:180px">
                    <label id="NewEditUserHeadLabel" for="NewEditUserHead">Responsable:</label>
                </td>
                <td>
                    <input id="NewEditUserHead" class="textEntry ui-corner-all"/>
                    <input id="NewEditUserHeadId" type="hidden" value="" />

                </td>
            </tr>
        </table>
    </div>
    <div>
        <table style="width:100%;">
            <colgroup>
                <col span="1" style="width: auto;" />
                <col span="1" style="width: auto;" />
            </colgroup>
            <tr>
                <td style="width:100px;height:100px;">
                    <asp:Image ID="ImgUsers" runat="server" Height="100px" Width="100px" ImageUrl="/images/users.png"  />
                </td>
                <td>
                    <div id="addNewSubmit" runat="server">
                        <input type="button" Value="Nou usuari" class="ui-button ui-widget ui-state-default ui-corner-all ui-button-text-only" ID="NewUserButton" onclick="javascript:Add();" />
                    </div>
                </td>
            </tr>
        </table>
        <div>
            <asp:GridView ID="gwUsers" runat="server"  CssClass="tableSearcher" AutoGenerateColumns="False" OnRowDataBound="gwUsers_RowDataBound" GridLines="None" ShowHeaderWhenEmpty="true">
                <Columns>
                    <asp:BoundField DataField="UserHandler" HeaderText="Id" />
                    <asp:BoundField DataField="FullName" HeaderText="Usuari" />
                    <asp:BoundField DataField="Type" HeaderText="Tipus" />
                    <asp:BoundField DataField="Username" HeaderText="Username" />
                    <asp:BoundField DataField="Email" HeaderText="Email" />
                    <asp:TemplateField HeaderText="Accions" HeaderStyle-Width="80px">
                        <ItemTemplate>
                            <input class="floatLeft ui-icon ui-icon-pencil <%# string.Concat("edit_",Eval("UserHandler")) %>" type="image" title="Editar" onclick='<%# Eval("UserHandler", "Edit({0});return false;").ToString() %>'>
                            <input class="floatLeft ui-icon ui-icon-trash <%# string.Concat("delete_",Eval("UserHandler")) %>" type="image" onclick='<%# Eval("UserHandler", "Delete({0});return false;").ToString() %>' title="Esborrar">
                        </ItemTemplate>
                    </asp:TemplateField>
                </Columns>
            </asp:GridView>
        </div>
    </div>
</asp:Content>
