﻿using GestorDespesesWeb.GestorDespesesWS;
using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace GestorDespesesWeb
{
    public partial class GestorDespeses : System.Web.UI.MasterPage
    {
        private static BasicHttpBinding binding = new BasicHttpBinding();
        private static EndpointAddress address = new EndpointAddress("http://192.168.1.75/GestorDespesesWS/GestorDespesesWS.svc");
        private static GestorDespesesWSClient client = new GestorDespesesWSClient(binding, address);

        protected void Page_Load(object sender, EventArgs e)
        {
            if (Session["userId"] != null)
            {
                bool isHeadUser = false;
                try
                {
                    isHeadUser = client.isCurrentUserHeadUser((string)Session["token"]);
                }
                catch { }
                List<MenuItem> toRemove = new List<MenuItem>();
                //Menu control
                foreach (MenuItem item in NavigationMenu.Items)
                {
                    bool isremoved = false;
                    if ((UserType)Session["userType"] == UserType.ADMINISTRATOR) //Administrator
                    {
                        if (item.NavigateUrl.ToLower().Contains("/worker/"))
                        {
                            toRemove.Add(item);
                            isremoved = true;
                        }
                    }
                    else
                    {
                        if (item.NavigateUrl.ToLower().Contains("/admin/"))
                        {
                            toRemove.Add(item);
                            isremoved = true;
                        }
                    }
                    if (isHeadUser == false) {
                        if (item.NavigateUrl.ToLower().Contains("/head/"))
                        {
                            toRemove.Add(item);
                            isremoved = true;
                        }
                    }

                    if (!isremoved && Request.Url.AbsoluteUri.ToLower().Contains(Page.ResolveUrl(item.NavigateUrl.ToLower())))
                    {
                        item.Selected = true;
                    }
                }
                foreach (MenuItem item in toRemove)
                {
                    NavigationMenu.Items.Remove(item);
                }
            }
        }
    }
}
