﻿<%@ Page Language="C#" MasterPageFile="~/GestorDespeses.Master"  AutoEventWireup="true" CodeBehind="Validation.aspx.cs" Inherits="GestorDespesesWeb.Head.Validation" %>
<asp:Content ID="Content1" ContentPlaceHolderID="HeadContent" runat="server">
    <script type="text/javascript" src="../Scripts/jquery.dataTables.js"></script>
    <script type="text/javascript">
        var oTable;
        var expensesTable;

        function View(expensesSheetId) {
            $.ajax({
                type: "POST",
                url: "Validation.aspx/getExpensesOfSheet",
                data: "{expensesSheetId: '" + expensesSheetId + "'}",
                dataType: "json",
                contentType: "application/json; charset=utf-8",
                success: function (data) {
                    if (data.d.success) {
                        expensesTable.fnClearTable();
                        $.each(data.d.list, function (index, d) {
                            var date = new Date(parseInt(d.Date.substr(6)));
                            var curr_date = padDigits(date.getDate(), 2);
                            var curr_month = padDigits(date.getMonth() + 1, 2); //Months are zero based
                            var curr_year = date.getFullYear();
                            var formattedDate = curr_date + "/" + curr_month + "/" + curr_year;
                            var type = "Fixe";
                            if (d.Type == 1) { type = "Variable"; }
                            if (d.Type == 2) { type = "Multiplicatiu"; }
                            var holidays = d.IsOnHolidays ? "Si" : "No";
                            var invoice = d.HasInvoice ? "Si" : "No";
                            expensesTable.dataTable().fnAddData([d.ExpenseHandler, d.TypeConcept, d.Description, type, formattedDate, d.TypeValue, holidays, invoice, d.Value, d.TotalValue]);
                        });
                        setTimeout(function () {
                            expensesTable.fnDraw();
                        }, 5);
                        $("#dialog-sheet-expenses").dialog({
                            title: 'Detall de despeses',
                            resizable: false,
                            height: 390,
                            width: 1000,
                            modal: true,
                            buttons: {
                                "Validar": function () {
                                    Validate(expensesSheetId);
                                    $(this).dialog("close");
                                },
                                "Rebutjar": function () {
                                    Revoke(expensesSheetId);
                                    $(this).dialog("close");
                                },
                                "Tancar": function () {
                                    $(this).dialog("close");
                                }
                            }
                        });
                    }
                    else {
                        if(data.d.error == "Token de sessió invàlid.") { location.replace("/Account/Login.aspx"); } else { showError(data.d.error); }
                        return false;
                    }
                },
                error: function (xmlhttprequest, textstatus, errorthrown) {
                    //alert("status: " + xmlhttprequest.status + "\r\n" + textstatus + "\r\n" + errorthrown);
                    showError("Error al llistar despseses d'un full de despeses");
                    return false;
                }
            });
        }

        function Validate(expensesSheetId) {
            showConfirm("Validació de full de despesa",
                "Està segur que vol validar el full de despeses?",
                function () {
                    $.ajax({
                        type: "POST",
                        url: "Validation.aspx/validateExpensesSheet",
                        data: "{expensesSheetId:'" + expensesSheetId + "'}",
                        dataType: "json",
                        contentType: "application/json; charset=utf-8",
                        success: function (data) {
                            if (data.d.success) {
                                var target_row = $('.validate_' + expensesSheetId).closest("tr").get(0); // this line did the trick
                                var aPos = oTable.fnGetPosition(target_row);
                                oTable.fnDeleteRow(aPos);
                                showInfo("Full de despeses validat correctament.");
                            } else {
                                if(data.d.error == "Token de sessió invàlid.") { location.replace("/Account/Login.aspx"); } else { showError(data.d.error); }
                            }
                        },
                        error: function (XMLHttpRequest, textStatus, errorThrown) {
                            showError('Error al validar el full de despeses.');
                        }
                    });
                },
                function () {
                    return false;
                }
            )
        }

        function Revoke(expensesSheetId) {
            $('#RevokeSheetReason').text('');
            $("#dialog-revoke-confirm").dialog({
                resizable: false,
                modal: true,
                width: "320px",
                buttons: {
                    "Si": function () {
                        if ($('#RevokeSheetReason').val() != null && $('#RevokeSheetReason').val() != "") {
                            $.ajax({
                                type: "POST",
                                url: "Validation.aspx/revokeExpensesSheet",
                                data: "{expensesSheetId:'" + expensesSheetId + "', reason:'" + $('#RevokeSheetReason').val() + "'}",
                                dataType: "json",
                                contentType: "application/json; charset=utf-8",
                                success: function (data) {
                                    if (data.d.success) {
                                        var target_row = $('.revoke_' + expensesSheetId).closest("tr").get(0); // this line did the trick
                                        var aPos = oTable.fnGetPosition(target_row);
                                        oTable.fnDeleteRow(aPos);
                                        showInfo("Full de despeses rebutjat correctament.");
                                        $(this).dialog("close");
                                    } else {
                                        if(data.d.error == "Token de sessió invàlid.") { location.replace("/Account/Login.aspx"); } else { showError(data.d.error); }
                                    }
                                },
                                error: function (XMLHttpRequest, textStatus, errorThrown) {
                                    showError('Error al rebutjar el full de despeses.');
                                }
                            });
                        } else {
                            showError('Per poder rebutjar un full de despeses ha d\'especificar un motiu.');
                        }
                    },
                    "No": function () {
                        $(this).dialog("close");
                        return false;
                    }
                }
            });
        }

        $(document).ready(function () {
            oTable = $('.tableSearcher').dataTable({
                "bJQueryUI": true,
                "sPaginationType": "full_numbers",
                "aoColumns": [ /* ID */  { "bVisible": false, "bSearchable": false }, null, null, null, { "bSearchable": false, 'bSortable': false }],
                "oLanguage": {
                    "sSearch": "Cercar:",
                    "sLengthMenu": "Mostrar _MENU_ fulls de despeses per pàgina",
                    "sZeroRecords": "Sense resultats",
                    "sEmptyTable": "No hi ha cap full de despeses per validar",
                    "sInfo": "Mostrant _START_ fins _END_ d'un total de _TOTAL_ fulls de despeses",
                    "sInfoEmpty": "Mostrant 0 fins 0 d'un total de 0 fulls de despeses",
                    "sInfoFiltered": "(cerca filtrada d'un total de _MAX_ fulls de despeses)",
                    "oPaginate": {
                        "sFirst": "Primer",
                        "sLast": "Últim",
                        "sNext": "Següent",
                        "sPrevious": "Anterior"
                    }
                }
            });

            expensesTable = $('.tableSearcherExpenses').dataTable({
                "sScrollY": "120px",
                "bJQueryUI": true,
                "sPaginationType": "full_numbers",
                "aoColumns": [ /* ID */  { "bVisible": false }, null, null, null, null, null, null, null, null, null],
                "oLanguage": {
                    "sSearch": "Cercar:",
                    "sLengthMenu": "Mostrar _MENU_ despeses per pàgina",
                    "sZeroRecords": "Sense resultats",
                    "sEmptyTable": "No hi ha cap despesa al full",
                    "sInfo": "Mostrant _START_ fins _END_ d'un total de _TOTAL_ despeses",
                    "sInfoEmpty": "Mostrant 0 fins 0 d'un total de 0 despeses",
                    "sInfoFiltered": "(cerca filtrada d'un total de _MAX_ despeses)",
                    "oPaginate": {
                        "sFirst": "Primer",
                        "sLast": "Últim",
                        "sNext": "Següent",
                        "sPrevious": "Anterior"
                    }
                },
                "fnFooterCallback": function (nRow, aaData, iStart, iEnd, aiDisplay) {
                    var iTotal = 0;
                    for (var i = 0 ; i < aaData.length ; i++) {
                        iTotal += Number(new String(aaData[i][9]).replace(",", "."));
                    }

                    $('#totalValue').find("p").text("Total: " + iTotal + "€");
                }
            });
        });
    </script>
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="BodyContent" runat="server">
    <div id="dialog-revoke-confirm" title="Confirmation" style="display: none;">
        <table>
            <colgroup>
                <col span="1" style="width: 50px;" />
                <col span="1" style="width: 250px" />
            </colgroup>
            <tr>
                <td colspan="2">
                    <p><span class="ui-icon ui-icon-alert" style="float: left; margin: 0 7px 20px 0;"></span></p>
                    <div>Està segur que vol rebutjar la despesa? Si és així indiqui un motiu a continuació.</div>
                </td>
            </tr>
            <tr>
                <td class="rightAlign" style="width:80px">
                    <label id="NewEditExpenseDesctription" for="NewEditExpenseDescription">Motiu:</label>
                </td>
                <td>
                    <input type="text" id="RevokeSheetReason" class="textEntry ui-corner-all"/>
                </td>
            </tr>
        </table>
    </div>
    <div id="dialog-sheet-expenses" style="display:none">
        <div style="font-family: Arial; font-size:small">
            <asp:GridView ID="gwExpenses" runat="server"  CssClass="tableSearcherExpenses" AutoGenerateColumns="False" GridLines="None" ShowHeaderWhenEmpty="true">
                <Columns>
                    <asp:BoundField DataField="ExpenseHandler" HeaderText="Id" />
                    <asp:BoundField DataField="TypeConcept" HeaderText="Concepte" />
                    <asp:BoundField DataField="Description" HeaderText="Descripció" />
                    <asp:BoundField DataField="Type" HeaderText="Tipus" />
                    <asp:BoundField DataField="Date" HeaderText="Data" />
                    <asp:BoundField DataField="TypeValue" HeaderText="Valor/Valor x u." />
                    <asp:BoundField DataField="IsOnHolidays" HeaderText="Festiu" />
                    <asp:BoundField DataField="HasInvoice" HeaderText="Tiquet" />
                    <asp:BoundField DataField="Value" HeaderText="Valor/Quantitat" />
                    <asp:BoundField DataField="TotalValue" HeaderText="Total(€)" />
                </Columns>
            </asp:GridView>
        </div>
        <div style="font-family: Arial; font-size:small">
            <table style="width:100%;">
                <colgroup>
                    <col span="1" style="width: auto;" />
                </colgroup>
                <tr style="text-align:right">
                    <td id="totalValue">
                        <p>Total:</p>
                    </td>
                </tr>
            </table>
        </div>
    </div>
    <div>
        <table style="width:100%;">
            <colgroup>
                <col span="1" style="width: auto;" />
                <col span="1" style="width: auto;" />
            </colgroup>
            <tr>
                <td style="width:100px;height:100px;">
                    <asp:Image ID="ImgValidation" runat="server" Height="100px" Width="100px" ImageUrl="/images/validate.png"  />
                </td>
            </tr>
        </table>
        <div>
            <asp:GridView ID="gwExpensesSheets" runat="server"  CssClass="tableSearcher" OnRowDataBound="gwExpensesSheets_RowDataBound" AutoGenerateColumns="False" GridLines="None" ShowHeaderWhenEmpty="true">
                <Columns>
                    <asp:BoundField DataField="ExpensesSheetHandler" HeaderText="Id" />
                    <asp:BoundField DataField="OwnerUsername" HeaderText="Usuari" />
                    <asp:BoundField DataField="Date" HeaderText="Pre-Validació" />
                    <asp:BoundField DataField="Value" HeaderText="Quantitat" />
                    <asp:TemplateField HeaderText="Accions" HeaderStyle-Width="80px">
                        <ItemTemplate>
                            <input class="floatLeft ui-icon ui-icon-script <%# string.Concat("view_",Eval("ExpensesSheetHandler")) %>" type="image" onclick='<%# Eval("ExpensesSheetHandler", "View({0});return false;").ToString() %>' title="Veure">
                            <input class="floatLeft ui-icon ui-icon-check <%# string.Concat("validate_",Eval("ExpensesSheetHandler")) %>" type="image" onclick='<%# Eval("ExpensesSheetHandler", "Validate({0});return false;").ToString() %>' title="Validar">
                            <input class="floatLeft ui-icon ui-icon-closethick <%# string.Concat("revoke_",Eval("ExpensesSheetHandler")) %>" type="image" onclick='<%# Eval("ExpensesSheetHandler", "Revoke({0});return false;").ToString() %>' title="Rebutjar">
                        </ItemTemplate>
                    </asp:TemplateField>
                </Columns>
            </asp:GridView>
        </div>
    </div>
</asp:Content>
