﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Web;

namespace GestorDespesesWeb
{
    public static class Utils
    {
        public static string FormatDecimal(decimal d)
        {
            char point = System.Globalization.NumberFormatInfo.CurrentInfo.NumberDecimalSeparator[0];
            string s = d.ToString();
            if (!s.Contains(point))
                return s;
            return s.TrimEnd('0').TrimEnd(point);
        }

        public static bool IsValidImage(byte[] bytes)
        {
            try
            {
                using (MemoryStream ms = new MemoryStream(bytes))
                    Image.FromStream(ms);
            }
            catch (ArgumentException)
            {
                return false;
            }
            return true;
        }
    }
}