﻿using GestorDespesesWeb.GestorDespesesWS;
using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace GestorDespesesWeb.Worker
{
    public partial class ExpenseUpload : System.Web.UI.Page
    {
        private static BasicHttpBinding binding = new BasicHttpBinding();
        private static EndpointAddress address = new EndpointAddress("http://192.168.1.75/GestorDespesesWS/GestorDespesesWS.svc");
        private static GestorDespesesWSClient client = new GestorDespesesWSClient(binding, address);

        protected void Page_Load(object sender, EventArgs e)
        {
            try
            {
                if (Session["userId"] == null || (UserType)Session["userType"] != UserType.WORKER)
                {
                    Response.Redirect("/Error/Error.aspx", false);
                }
            }
            catch
            {
                Response.Redirect("/Error/UnexpectedError.aspx");
            }
        }

        protected void UploadFileToServer(object sender, EventArgs e)
        {
            try
            {
                if (HttpContext.Current.Session["userId"] != null && (UserType)HttpContext.Current.Session["userType"] == UserType.WORKER)
                {
                    if (FileUpload1.FileBytes.Length == 0 || Utils.IsValidImage(FileUpload1.FileBytes) == true)
                    {
                        string[] parts = ExpenseDate.Text.Split('/');
                        DateTime dateTime = new DateTime(Convert.ToInt32(parts[2]), Convert.ToInt32(parts[1]), Convert.ToInt32(parts[0]));
                        if (String.IsNullOrEmpty(ExpenseHandler.Text))
                        {
                            int newId = client.addExpense(Convert.ToDecimal(ExpenseValue.Text), dateTime, ExpenseDescription.Text, FileUpload1.FileBytes, ExpenseTypeConcept.Text, (string)HttpContext.Current.Session["token"]);
                        }
                        else
                        {
                            bool edited = client.editExpense(Convert.ToInt32(ExpenseHandler.Text), Convert.ToDecimal(ExpenseValue.Text), dateTime, ExpenseDescription.Text, ExpenseInvoiceDeleted.Checked ? null : FileUpload1.FileBytes, ExpenseTypeConcept.Text, (string)HttpContext.Current.Session["token"]);
                        }
                        FileUploadRes.Text = "true";
                    }
                    else
                    {
                        FileUploadRes.Text = "El fitxer no correspon a una imatge vàlida.";
                    }
                }
                else
                {
                    FileUploadRes.Text = "No autoritzat.";
                }
            }
            catch (FaultException<GestorDespesesFault> fedf)
            {
                if (fedf.Detail.Message.Equals("Token de sessió invàlid."))
                {
                    Response.Redirect("/Account/Login.aspx", false);
                }
                else
                {
                    FileUploadRes.Text = fedf.Detail.Message;
                }
            }
            catch (Exception)
            {
                FileUploadRes.Text = "Error desconegut.";
            }
        }
    }
}
